package com.jasamedika.medifirst2000.entities;

import java.io.Serializable;
import org.hibernate.envers.Audited;
import java.util.Date;

import javax.persistence.*;

import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.BaseMaster;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.BaseMaster;
import com.jasamedika.medifirst2000.helper.Caption;
import org.hibernate.envers.Audited;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

/**
 * class PersenTanggunganPenjaminD
 * 
 * @author Generator
 */
@Entity // @Audited
@Table(name = "PersenTanggunganPenjaminD_M")
public class PersenTanggunganPenjaminD extends BaseMaster {
	@ManyToOne
	@JoinColumn(name = "ObjectGolonganAsuransiFk")
	@NotNull(message = "Kd Golongan Asuransi tidak boleh kosong")

	@Caption(value = "Object Golongan Asuransi")
	private GolonganAsuransi kdGolonganAsuransi;

	public void setGolonganAsuransi(GolonganAsuransi kdGolonganAsuransi) {
		this.kdGolonganAsuransi = kdGolonganAsuransi;
	}

	public GolonganAsuransi getGolonganAsuransi() {
		return this.kdGolonganAsuransi;
	}

	@Column(name = "ObjectGolonganAsuransiFk", insertable = false, updatable = false)
	private Integer golonganAsuransiId;

	@NotNull(message = "Kd Hubungan Asuransi tidak boleh kosong")
	@Column(name = "KdHubunganAsuransi", nullable = false)
	@Caption(value = "Kode Hubungan Asuransi")
	private Byte kdHubunganAsuransi;

	public void setKdHubunganAsuransi(Byte kdHubunganAsuransi) {
		this.kdHubunganAsuransi = kdHubunganAsuransi;
	}

	public Byte getKdHubunganAsuransi() {
		return this.kdHubunganAsuransi;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectJenisPerawatanFk")
	@NotNull(message = "Kd Jenis Perawatan tidak boleh kosong")

	@Caption(value = "Object Jenis Perawatan")
	private JenisPerawatan jenisPerawatan;

	public void setJenisPerawatan(JenisPerawatan jenisPerawatan) {
		this.jenisPerawatan = jenisPerawatan;
	}

	public JenisPerawatan getJenisPerawatan() {
		return this.jenisPerawatan;
	}

	@Column(name = "ObjectJenisPerawatanFk", insertable = false, updatable = false, nullable = false)
	private Integer jenisPerawatanId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelasFk")
	@NotNull(message = "Kd Kelas tidak boleh kosong")

	@Caption(value = "Object Kelas")
	private DetailKamar kelas;

	public void setKelas(DetailKamar kelas) {
		this.kelas = kelas;
	}

	public DetailKamar getKelas() {
		return this.kelas;
	}

	@Column(name = "ObjectKelasFk", insertable = false, updatable = false, nullable = false)
	private Integer kelasId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelompokPasienFk")
	@NotNull(message = "Kd Kelompok Pasien tidak boleh kosong")

	@Caption(value = "Object Kelompok Pasien")
	private KelompokPasien kelompokPasien;

	public void setKelompokPasien(KelompokPasien kelompokPasien) {
		this.kelompokPasien = kelompokPasien;
	}

	public KelompokPasien getKelompokPasien() {
		return this.kelompokPasien;
	}

	@Column(name = "ObjectKelompokPasienFk", insertable = false, updatable = false, nullable = false)
	private Integer kelompokPasienId;

	@NotNull(message = "Kd Penjamin Pasien tidak boleh kosong")
	@Column(name = "KdPenjaminPasien", nullable = false)
	@Caption(value = "Kode Penjamin Pasien")
	private short kdPenjaminPasien;

	public void setKdPenjaminPasien(short kdPenjaminPasien) {
		this.kdPenjaminPasien = kdPenjaminPasien;
	}

	public short getKdPenjaminPasien() {
		return this.kdPenjaminPasien;
	}

	@NotNull(message = "Max T Penjamin tidak boleh kosong")
	@Column(name = "MaxTPenjamin", nullable = false)
	@Caption(value = "Max T Penjamin")
	private Double maxTPenjamin;

	public void setMaxTPenjamin(Double maxTPenjamin) {
		this.maxTPenjamin = maxTPenjamin;
	}

	public Double getMaxTPenjamin() {
		return this.maxTPenjamin;
	}

	@NotNull(message = "Qty Max Kunjungan tidak boleh kosong")
	@Column(name = "QtyMaxKunjungan", nullable = false)
	@Caption(value = "Qty Max Kunjungan")
	private short qtyMaxKunjungan;

	public void setqtyMaxKunjungan(short qtyMaxKunjungan) {
		this.qtyMaxKunjungan = qtyMaxKunjungan;
	}

	public short getqtyMaxKunjungan() {
		return this.qtyMaxKunjungan;
	}

	@Column(name = "TglBerlakuAkhir", nullable = true)
	@Caption(value = "Tanggal Berlaku Akhir")
	private Date tglBerlakuAkhir;

	public void setTglBerlakuAkhir(Date tglBerlakuAkhir) {
		this.tglBerlakuAkhir = tglBerlakuAkhir;
	}

	public Date getTglBerlakuAkhir() {
		return this.tglBerlakuAkhir;
	}

	@NotNull(message = "Tgl Berlaku Awal tidak boleh kosong")
	@Column(name = "TglBerlakuAwal", nullable = false)
	@Caption(value = "Tanggal Berlaku Awal")
	private Date tglBerlakuAwal;

	public void setTglBerlakuAwal(Date tglBerlakuAwal) {
		this.tglBerlakuAwal = tglBerlakuAwal;
	}

	public Date getTglBerlakuAwal() {
		return this.tglBerlakuAwal;
	}

	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "public.persentanggunganpenjamind_m_id_seq")
	@javax.persistence.SequenceGenerator(name = "public.persentanggunganpenjamind_m_id_seq", sequenceName = "public.persentanggunganpenjamind_m_id_seq", allocationSize = 1)
	@Column(name = "id")
	protected Integer id;

	public Integer getId() {

		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}
}